//
// motor.c : n݌v H8/36064 DC[^p֐
//

// @@Ӂ@
// VstoneА}CR{[hiVS-WRC003j́wVS-WRC003 eNjJ}jAxɂ́A
// P60[qiFTIOA0jPWMo͂pāACN1/M1RlN^DC[^]łƏĂ邪A
// ۂɂ́AFTIOA0PWMo͂̋@\LĂȂB
// (uH8/36064 O[vn[hEFA}jA w12. ^C}Z@12.2 o͒[qxvQ)
// ̂߁A{DC[^֘A֐Cuł́AP60[qiFTIOA0jACN1/M1RlN^舵ȂB


#include <machine.h>
#include "iodefine.h"
#include "motor.h"

void MotorInit(char port)
{
	/* ]EPWM̃|[g̐ݒ */
	switch (port) {
		case 0:	// ]FP32, P33   PWMFP61   CN2o
			IO.PCR3 |= 0x0C;	// P32, P33o͂ɐݒ
			IO.PDR3.BIT.B2 = 0;	// P32̏l0ɐݒ
			IO.PDR3.BIT.B3 = 0;	// P33̏l0ɐݒ
			IO.PCR6 |= 0x02;	// P61o̓|[gɂ
			break;
			
			// IvVp@Ⴄ`l CN1o //
	case 1:	// ]FP30, P31       PWMFP60
			IO.PCR3 |= 0x03;	// P30,P31o͂ɐݒ
			IO.PDR3.BIT.B0 = 0;	// P30̏l0ɐݒ
			IO.PDR3.BIT.B1 = 0;	// P31̏l0ɐݒ
			IO.PCR6 |= 0x01;	// P60o̓|[gɂ
			break;

		default:
			break;
	}

	/* ^C}Z0̐ݒ */
	set_imask_ccr(1);		// ^C}̐ݒ̑Oɂ͂
	TZ0.TCR.BIT.TPSC = 2;	// [010] /4ŃJEg

	switch (port) {
		case 0:	// ]FP32, P33   PWMFP61  CN2o
			TZ.TPMR.BIT.PWMB0 = 1;	// FTIOB0PWMo͂ɐݒ
			TZ.TOER.BIT.EB0 = 0;	// P61/FTIOB0^C}o͂ƂĎgp
			TZ.TOCR.BIT.TOB0 = 1;	// FTIOB0̏o͂1ɃZbg
			TZ0.TIORA.BIT.IOB = 1;	// [001] RyA}b`FTIOB0̏o0
			TZ0.GRB = 0;			// FTIOB0̃f[eB0
			break;
			
				// IvVp@Ⴄ`l CN1o //
		case 1:	// ]FP30, P31       PWMFP60
			TZ0.TCR.BIT.CCLR = 0;  // JE^NA̐ݒ
			TZ0.TIER.BIT.OVIE = 1; // 荞ݐݒ@荞ݏTSRWX^̊荞݃tOOVF0ɃNA邱
			TZ.TOER.BIT.EA0 = 0;	// P60/FTIOA0^C}o͂ƂĎgp
			TZ.TOCR.BIT.TOA0 = 1;	// FTIOA0̏o͂1ɃZbg
			TZ0.TIORA.BIT.IOA = 1;	// [001] RyA}b`FTIOA0̏o0
			TZ0.GRA = 0;			// FTIOB0̃f[eB0
			break;

		default:
			break;
	}
	
	TZ.TSTR.BIT.STR0 = 1;	// JEgX^[g
	set_imask_ccr(0);		// ^C}ݒ肵I炱
}



void Motor(char port, char dir, unsigned int duty)
{
	switch (port) {
		case 0:	// ]FP32, P33   PWMFP61
			if (dir == 0) {				/* Oi */
				IO.PDR3.BIT.B2 = 1;		// P32o͒l = 1
				IO.PDR3.BIT.B3 = 0;		// P33o͒l = 0
			} else {					/* i */
				IO.PDR3.BIT.B2 = 0;		// P32o͒l = 0
				IO.PDR3.BIT.B3 = 1;		// P33o͒l = 1
			}

			TZ0.GRB = duty;				// GRBɃRyAlݒ
			break;
			
		case 1:	// ]FP30, P31        PWMFP60
			if (dir == 0) {				/* Oi */
				IO.PDR3.BIT.B0 = 1;		// P30o͒l = 1
				IO.PDR3.BIT.B1 = 0;     // P31o͒n = 0
			} else {					/* i */
				IO.PDR3.BIT.B0 = 0;		// P30o͒l = 0
				IO.PDR3.BIT.B1 = 1;     // P31o͒n = 1
			}

			TZ0.GRA = duty;			// GRDɃRyAlݒ
			break;

		default:
			break;
	}
}